#include <stdio.h>   // vstup-vystup
#include <windows.h>  //potreba jen pro funkci Sleep
#include "decl-32.h"  // GPIB ovladac, pouze hlavickovy soubor .h
// je potreba prilozit pro linkovani zkompilovany ovladac gpib-32.obj
// v prostredi Code::Blocks se toto dela skrz Project->Build options -> Linker Settings


#define ARRAYSIZE 100            // Size of read buffer
int  Dev;                        // Device handle
char ReadBuffer[ARRAYSIZE + 1];  // Read data buffer
float   V;  // vstupni napeti cislo
char Vchar[40];  // vstupni napeti retezec znaku
int delkaVchar;
char Ichar[12]="";  // vystupni proud retezec znaku
int i;


void GPIBCleanup(int Dev, char* ErrorMsg);

int _cdecl main(void)  {

#define BDINDEX               0     // Board Index
#define PRIMARY_ADDR_OF_DMM   22     // Primary address of device
#define NO_SECONDARY_ADDR     0     // Secondary address of device
#define TIMEOUT               T10s  // Timeout value = 10 seconds
#define EOTMODE               1     // Enable the END message
#define EOSMODE               0     // Disable the EOS mode

// Inicializace zarizeni Dev
Dev = ibdev (BDINDEX, PRIMARY_ADDR_OF_DMM, NO_SECONDARY_ADDR,TIMEOUT, EOTMODE, EOSMODE);
if (ibsta & ERR) { GPIBCleanup(Dev, "Unable to open device");  return 1; }

/*Clear the internal or device functions of the device.  If the error
 *  bit ERR is set in ibsta, call GPIBCleanup with an error message. */
ibclr (Dev);
if (ibsta & ERR){ GPIBCleanup(Dev, "Unable to clear device");  return 1; }


//Prikazy ke Keithley 487 jsou vzdy ve formatu retezce a ukonceny X
// pokud se posle neplatny prikaz, na displeji se objevi IDDC
ibwrt (Dev, "R0X", 3);  // nastav autorange.
printf("Probiha nulovani pikoampermetru\n");
ibwrt (Dev, "C2X", 3);  // proved corekci na nulu
ibwrt (Dev, "C0X", 3);  // vypni zero check
ibwrt (Dev, "O1X", 3);  // nastavi zdroj na operate


if (ibsta & ERR)   {       GPIBCleanup(Dev, "Error zerocheck the device");    return 1;    }


V=1;  //pozadovane napeti ve forme cisla
if (abs(V)>50){
    printf("Pozadovane napeti je vetsi nez bezpecny limit 50 V");
    ibonl (Dev, 0);
    return 1;
    }

delkaVchar =sprintf(Vchar, "V%2.3fX", V);  //vytvoreni retezce z cisla v pozadovanem formatu
printf("Vchar je %s", Vchar);
ibwrt (Dev, Vchar, delkaVchar);  // nastaveni pikoampermetru na pozadovane napeti
Sleep(100); //pocka dobu v ms, aby se ustabilizovalo napeti

ibrd (Dev, ReadBuffer, ARRAYSIZE);  // precte proud ze zarizeni
if (ibsta & ERR){ GPIBCleanup(Dev, "Unable to read data from device"); return 1; }
printf("Returned string:  %s\n", ReadBuffer); // Navraceny retezec je text s cislem napr.: NDCI+0.00018E-09
// Prekopiruje z ReadBuffer do Ichar jen cislo, ibcnt je globalni promenna s delkou precteneho retezce. Z nejakeho duvodu jsou tam dva znaky navic
for (i=4;i<ibcnt-2;i++){Ichar[i-4]=ReadBuffer[i];}
Ichar[12] = '\0';   // ukoncuje string v jazyku c
printf("Ichar je %s\n", Ichar);


system("pause"); // ceka na stisk klavesy
/*  Take the device offline.                                                */
ibwrt (Dev, "O0X", 3);  // vypne operate
Sleep(100); //pocka dobu v ms,
ibonl (Dev, 0);
return 0;

}


void GPIBCleanup(int ud, char* ErrorMsg)
{
    printf("Error : %s\nibsta = 0x%x iberr = %d\n",
            ErrorMsg, ibsta, iberr);
    if (ud != -1)
    {
       printf("Cleanup: Taking device offline\n");
       ibonl (ud, 0);
    }
}


