# nacteni dat
from numpy import array,zeros,sqrt,genfromtxt
dat=genfromtxt("data/ReflexeSiO2naSi.csv",delimiter=",",skip_header=2,skip_footer=50,unpack=True,usecols=(0,1))
# kalibracni data 
cal=genfromtxt("data/HLINIK_fine.DAT",unpack=True)
#sub=genfromtxt("data/si_refl.csv",delimiter=",",skip_header=2,skip_footer=2,unpack=True,usecols=(0,1))

# meze, kde jsou kalibracni data vhodna (a vrstva bez absorbce)
wmin,wmax=315,795 # v nm
sel=(dat[0]>wmin)*(dat[0]<=wmax) #vyber oblasti vstup. souboru
x=1238./dat[0][sel] # prepocet do eV
y=dat[1][sel]
calsel=(cal[0]>wmin)*(cal[0]<=wmax) #vyber stejne oblasti kalib. dat (predpokladame mereni ve stejnych bodech)
c=cal[1][calsel][::-1]
y/=c*100 # nyni je y absolutni reflektivita

#dielektricke funkce
cau_sio2=[1.4493423,1.961953e-03,1.68683e-05] # Cauchyho formule pro SiO2
#lor_si=[-2.61678, [[1.79418744e+02, 5.41916478e+00, 1.0e-03],[  16.3506, 3.17564, 1.21380e-01], [1.38945163e+02, 4.60986142e+00,1.0e-03]]]# precise from Aspnes
lor_si=[ 1.9330, [[13.5987,  5.19495,  0.4829],[101.8363, 4.1194,  0.8273], [37.5503,  3.45024,    0.4094]]] # 3 nafitovane oscilatory na eps. Si do 5eV
def dielect(freq,einf,osci):
	#vypocet epsilon z Lorentzovych oscilatoru
    e=zeros(len(freq),dtype='complex128')+einf
    for o in osci:
        e+=o[0]/(o[1]**2-freq**2-1j*o[2]*freq)
    return e
    
eps_si=dielect(x,lor_si[0],lor_si[1])
n_si=sqrt(eps_si)

def refl_lay(n_ox,n_si,d=780.7):
	# vypocet reflektivity tenke vrstvy
	# d - tloustka v nm
    rf_2=(n_si-n_ox)/(n_ox+n_si)
    sh=x/1238*2*pi*n_ox*d
    rf_1=(n_ox-1)/(n_ox+1)
    rf_tot=(rf_1+rf_2*exp(2j*sh))/(1+rf_1*rf_2*exp(2j*sh))
    return abs(rf_tot)**2

from scipy import optimize
# dostaneme hodnoty parametru v optimu a kovariacni matici
cpar,mcov=optimize.curve_fit(lambda x,a,b,c,d,e:(refl_lay(polyval([d,c,b],x**2),n_si,a)/e),x,y,[800.]+list(cau_sio2)+[1.])
cerr=sqrt(mcov.diagonal()) # nejistoty parametru
# a korelacni matice
mcor=mcov/cerr[:,newaxis]/cerr[newaxis,:]
cpname=['tloust.','A','B','C','renorm']
for i in range(len(cpar)):
	print cpname[i]+':  '+cpar[i]+'+-'+cerr[i]
print "korel. matice :\n",mcorr
